<!DOCTYPE html>
<!--
To change this license header, choose License Headers in Project Properties.
To change this template file, choose Tools | Templates
and open the template in the editor.
-->
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">  
        <meta content="IE=edge" http-equiv="X-UA-Compatible"> 
        <meta content="width=device-width,initial-scale=1" name="viewport"> 
        <meta content="Aulas de introcução à computação científica." name="description"> 
        <meta content="Markinho" name="author"> 
        
        <title> Entrada do usuário e manipulação de erros </title> 
        
        <link href="./css/bootstrap.min.css" rel="stylesheet">        
        <link href="./css/docs.min.css" rel="stylesheet">
        <link href="./css/carbonads.css" rel="stylesheet">
        <link href="./css/prism.css" rel="stylesheet">
        
        <link href="../imagens/favicon.ico" rel="icon"> 
        
        <script type="text/x-mathjax-config">
            MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
        </script>
        <script type="text/javascript" async
            src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS_CHTML">
        </script>
        
    </head>
    <body>
        
        <!-- Cabeçalho -->
        <div class="v4-tease">
            <a href="http://www.estruturas.ufpr.br">
                <img style="position: absolute; top: 0; left: 0; border: 0;" 
                     src="../imagens/estruturasUFPR.png" alt="Voltar para Estruturas.UFPR">
            </a>
            <a class="navbar-brand" style="position: absolute; left: 360px;" href="../index.html">
                Aulas de Introdução a Computação Científica
            </a>
        </div>
         <!-- FINAL Cabeçalho -->
        
        <!-- Menu superior -->
        <header class="bs-docs-nav navbar navbar-static-top" id="top"> 
            <div class="container"> 
                <div class="navbar-header"> 
                    <button aria-controls="bs-navbar"  
                            class="collapsed navbar-toggle" data-target="#bs-navbar" 
                            data-toggle="collapse" type="button"> 
                        <span class="sr-only">Alternar Navegação</span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                        <span class="icon-bar"></span> 
                    </button>
                </div> 
                <nav class="collapse navbar-collapse" id="bs-navbar"> 
                    <ul class="nav navbar-nav"> 
                        <li class="active"> <a href="lacoslistas.html">Entrada do usuário e manipulação de erros</a> </li>
                        <li><a href="#final">Tarefa</a></li>
                    </ul> 
                    <ul class="nav navbar-nav navbar-right"> 
                        <li class="dropdown" id="accountmenu">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">Demais tópicos abordados<b class="caret"></b></a>
                            <ul class="dropdown-menu">
                                <li><a href="../index.html#___sec0">Programando equações</a></li>
                                <li><a href="../index.html#___sec1">Laços e listas</a></li>
                                <li><a href="../index.html#___sec2">Funções e ramificações</a></li>
                                <li><a href="../index.html#___sec3">Entrada do usuário e manipulação de erros</a></li>
                                <li><a href="../index.html#___sec4">Arranjos e gráficos de curvas</a></li>            
                                <li><a href="../index.html#___sec6">Dicionários e cadeias de caracteres</a></li>
                                <li><a href="../index.html#___sec7">Introdução a Classes</a></li>            
                                <li><a href="../index.html#___sec9">Programação orientada a objeto</a></li>
                                <li><a href="../index.html#___sec10">Números aleatórios e jogos simples</a></li>
                                <li><a href="../index.html#___secA">Sequências e relações de recorrência</a></li>
                                <li><a href="../index.html#___secB">Programação de equações diferenciais</a></li>
                                <li><a href="../index.html#___secC">Gráficos tridimensionais</a></li>
                                <li><a href="../index.html#___secD">Programação em paralelo</a></li>
                                <li><a href="../index.html#___secE">Interfaces gráficas de usuário (GUI)</a></li>
                                <li><a href="../index.html#___secF">Migrando Python para código compilado</a></li> 
                            </ul>
                        </li> 
                    </ul> 
                </nav> 
            </div> 
        </header>
        <!-- FINAL MENU SUPERIOR -->
        
        <!-- Painel Superior -->
        <div class="bs-docs-header" id="content" tabindex="-1"> 
            <div class="container"> 
                <h1>Entrada do usuário e manipulação de erros</h1> 
                <p>Deixe para depois... faça agora genérico!<br>
                <font size="2px">Prof. Marco André Argenta / PPGECC / UFPR</font></p>
                <div id="carbonads-container">
                    <div class="carbonad">
                        <div id="azcarbon">
                            <a href="./imagens/programando_equacoes.png" target="_blank">
                                <!-- Imagens em 120 px altura e 300 px largura -->
                                <img src="./imagens/entradaerros.png" class="carbonad-image carbonad-img">
                            </a>
                        </div>
                    </div>
                </div> 
            </div> 
        </div>
        <!-- FINAL PAINEL SUPERIOR -->
        
        <!-- Parte principal -->
        <div class="container bs-docs-container">
            <div class="row">
                
                <!-- Conteúdo Principal -->
                <div class="col-md-9" role="main">
                    <div class="bs-docs-section"> 
                        <h1 class="page-header" id="inicio">Entrada do usuário e manipulação de erros</h1> 
                        <div class="well">
                            Dados de entrada pode ser definidos diretamente no programa,
                            ou seja, especificar explicitamente os valores de variáveis:
                            <code>A = 0.1</code> ou <code>w = 1</code>, o que pode ser 
                            adequado para pequenos programas ou programas específicos.
                            No geral, é considerado uma boa prática deixar que o usuário 
                            forneça os dados de entrada quando o programa está rodando,
                            sendo desnecessário modificar o programa propriamente dito
                            para um novo conjunto de dados.
                        </div>               
                    </div>
                    <div class="bs-docs-section" id="dados_entrada">
                        <h1 class="page-header">Dados de entrada no código</h1>

                        <p>Até agora, vínhamos escrevendo nossos dados de
                        entrada diretamente no código.</p>
                        
                        $$ y = v_0t - 0.5gt^2 $$
                        
                        <pre><code class="language-python">
v0 = 5
g = 9.81
t = 0.6
y = v0*t - 0.5*g*t**2
print y
                        </code></pre>
                        
                        <p>Notas:</p>
                        <ul>
                            <li>Dados de entrada foram explicitamente definidos;</li>
                            <li>Mudanças nos dados de entrada requer uma edição
                            do código;</li>
                            <li>Isso é considerado uma programação ruim, pois a
                            edição de programas pode facilmente introduzir erros
                            no código.</li>
                            <li>Regra: leia a entrada do usuário, evite editar
                            um programa funcional!</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="dados_entrada_pro">
                        <h1 class="page-header">Como programas profissionais 
                        obtém suas entradas?</h1>

                        <ul>
                            <li>Considere um navegador da internet: como você define
                            um endereço da web? Como você modifica o zoom?</li>
                            <li>Você não vai editar o código fonte do programa
                            para isso...</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="dados_entrada_esp">
                        <h1 class="page-header">Como podemos especificar
                        dados de entrada em programas?</h1>

                        <ul>
                            <li>Valores definidos explicitamente;</li>
                            <li>Perguntar ao usuário e ler as respostas;</li>
                            <li>Ler os argumentos de linha de comando;</li>
                            <li>Ler dados de um arquivo.</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="entrada_pergunta_resposta">
                        <h1 class="page-header">Obtendo a entrada de perguntas e
                        respostas</h1>

                        <p>Programa de exemplo:</p>
                        <pre><code class="language-python">
C = 21; F = (9.0/5)*C + 32; print F
                        </code></pre>
                        
                        <p>Ideia: faça o programa perguntar ao usuário "C = ?", leia a
                        resposta do usuário e atribua essa resposta a variável C.</p>
                        
                        <pre><code class="language-python">
C = raw_input('C=? ')   # C becomes a string
C = float(C)            # convert to float so we can compute
F = (9./5)*C + 32
print F
                        </code></pre>
                        
                        <p>Rodando em uma janela no terminal:</p>
                        
                        <pre><code class="language-bash">
Terminal> python c2f_pr.py
C=? 21
69.8
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dados_entrada_exe2">
                        <h1 class="page-header">Outro exemplo: imprima os
                        primeiros n números pares</h1>

                        <pre><code class="language-python">
n = int(raw_input('n=? '))

for i in range(2, 2*n+1, 2):
    print i

#ou:
print range(2, 2*n+1, 2)

#ou:
for i in range(1, n+1):
    print 2*i
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="dados_entrada_linhaComando">
                        <h1 class="page-header">Argumentos de linha de comando</h1>

                        <p>Argumentos de linha de comando são palavras escritas
                        após o nome do programa.</p>
                        <p>Exemplos de argumentos de linha de comando:</p>
                        <pre><code class="language-bash">
Terminal> python meuProg.py arg1 arg2 arg3 ...
Terminal> cp -r seuDir ../meuDir
Terminal> ls -l
                        </code></pre>
                        
                        <p>Programas Unix (<em>rm, ls, cp, ...)</em> faz o
                        uso pesado de argumentos de linha de comando, nós
                        vamos fazer o mesmo.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="argLinhaComando">
                        <h1 class="page-header">Como usar argumentos de
                        linha de comando</h1>

                        <p>Usando argumentos de linha de comando em nosso 
                        programa de exemplo</p>
                        
                        <pre><code class="language-python">
C = 21; F = (9.0/5)*C + 32; print F
                        </code></pre>
                        
                        <p>O usuário quer especificar C como um argumento
                        de linha de comando:</p>
                        
                        <pre><code class="language-bash">
Terminal> python c2f_cml.py 21
69.8
                        </code></pre>
                        
                        <p>Argumentos de linha de comando são "palavras" após
                        o nome do arquivo do programa e são armazenadas em 
                        uma lista que pode ser acessada com <code>sys.argv</code>:</p>
                        
                        <pre><code class="language-python">
import sys
C = float(sys.argv[1])   #lê o primeiro argumento de linha de comando
F = 9.0*C/5 + 32
print F
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="argLinhaComandosep">
                        <h1 class="page-header">Argumentos de linha de comando
                        são separados por espaços</h1>

                        <p>Um outro exemplo:</p>
                        
                        <pre><code class="language-python">
import sys; print sys.argv[1:]
                        </code></pre>
                        
                        <p>Demonstração:</p>
                        
                        <pre><code class="language-bash">
Terminal> python print_cml.py 21 cadeia de caracteres 1.3
['21', 'cadeia', 'de', 'caracteres', '1.3']

Terminal> python print_cml.py 21 "cadeia de caracteres" 1.3
['21', 'string with blanks', '1.3']
                        </code></pre>
                        
                        <p>Notas:</p>
                        <ul>
                            <li>Use aspas, como em "cadeia de caracteres" para
                            sobrescrever a regra de separar argumentos de linha
                            de comando com espaços;</li>
                            <li>Todos os elementos da lista estão entre aspas,
                            mostrando que os argumentos de linha de comando são
                            cadeias de caracteres.</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="eval_string">
                        <h1 class="page-header">Função <code>eval</code> em
                        cadeias de caracteres</h1>

                        <p>A função <code>eval()</code> transforma uma cadeia de
                        caracteres em código utilizável:</p>
                        
                        <pre><code class="language-python">
>>> s = '1+2'
>>> r = eval(s)
>>> r
3
>>> type(r)
&lt;type 'int'&gt;

>>> r = eval('[1, 6, 7.5] + [1, 2]')
>>> r
[1, 6, 7.5, 1, 2]
>>> type(r)
&lt;type 'list'&gt;
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="cuidade_eval_str">
                        <h1 class="page-header">Seja cuidadoso com o 
                            <code>eval</code></h1>

                        <p>Cuidado com o <code>eval</code> e os valores
                        da cadeia de caracteres.</p>
                        <p>Queremos <em>r = 'programa de valores'</em>.
                        Se escrevermos:</p>
                        <pre><code class="language-python">
r = eval('programa de valores')
                        </code></pre>
                        
                        <p>É a mesma coisa que:</p>
                        <pre><code class="language-python">
r = programa de valores
                        </code></pre>
                        <p>Que é uma expressão inválida e uma sintaze ilegal!</p>
                        <p>A solução é colocar aspas dentro de aspas:</p>
                        <pre><code class="language-python">
s = "'programa de valores'"
r = eval(s)                # r se torna 'programa de valores'
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="eval_faz">
                        <h1 class="page-header">Com <code>eval</code> um pequeno
                        programa pode muito</h1>

                        <p>Programa:</p>
                        <pre><code class="language-python">
i1 = eval(raw_input('Valor 1: '))
i2 = eval(raw_input('Valor 2: '))
r = i1 + i2
print '%s + %s se torna %s\n com valor %s' % \
      (type(i1), type(i2), type(r), r)
                        </code></pre>
                        <p>Podemos adicionar inteiros e pontos flutuantes:</p>
                        <pre><code class="language-bash">
Valor 1: 1
Valor 2: 3.0
&lt;type 'int'&gt; + &lt;type 'float'&gt; se torna &lt;type 'float'&gt;
com valor 4
                        </code></pre>
                        <p>Ou duas listas:</p>
                        <pre><code class="language-bash">
Valor 1: [1,2]
Valor 2: [-1,0,1]
&lt;type 'list'&gt; + &lt;type 'list'&gt; se torna &lt;type 'list'&gt;
com valor [1, 2, -1, 0, 1]
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="eval_flex">
                        <h1 class="page-header">Grande flexibilidade do <code>eval</code>
                        grande problema</h1>

                        <p>Sua grande flexibilidade também quebra rapidamente programas:</p>
                        <pre><code class="language-bash">
Valor 1: (1,2)
Valor 2: [3,4]
Traceback (most recent call last):
    r = i1 + i2
TypeError: can only concatenate tuple (not "list") to tuple

Valor 1: um
Traceback (most recent call last):
    i1 = eval(raw_input('operand 1: '))
  File "&lt;string>", line 1, in &lt;module&gt;
NameError: name 'um' is not defined

Valor 1: 4
Valor 2: 'Oi, senhor eval!'
Traceback (most recent call last):
    r = i1 + i2
TypeError: unsupported operand type(s) for +: 'int' and 'str'
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="func_exec">
                        <h1 class="page-header">Uma função similar <code>exec</code></h1>
                        
                        <ul>
                            <li><code>eval(s)</code> avalia uma expressão <code>s</code>;</li>
                            <li><code>eval('r = 1 + 1')</code> é ilegal porque é uma
                            declaração, não uma expressão;</li>
                            <li>...mas podemos usa o <code>exec</code> para
                            transformar uma ou mais declarações completas para
                            dentro do código.</li>
                        </ul>
                        <pre><code class="language-python">
declaracao = 'r = 1+1'   #armazena a declaração em uma cadeia de caracteres
exec(declaracao)
print r                 #imprime 2
                        </code></pre>
                        <p>Para códigos longos podemos utilizar as cadeias
                        de caracteres multilinha:</p>
                        <pre><code class="language-python">
import math

umcodigo = '''
def f(t):
    term1 = math.exp(-a*t)*math.sin(w1*x)
    term2 = 2*math.sin(w2*x)
    return term1 + term2
'''
exec(umcodigo)  #executa a cadeia de caracteres como um código Python
                        </code></pre>                        
                        
                    </div>
                    <div class="bs-docs-section" id="func_aovivo">
                        <h1 class="page-header"><code>exec</code> para função
                        em tempo de execução</h1>

                        <p>O <code>exec</code> pode ser utilizado para contruir
                        uma função em tempo de execução.</p>
                        <p>Embutindo uma formula de usuário em uma função Python:</p>
                        <pre><code class="language-python">
import math

formula = raw_input('Escreva uma fórmula envolvendo x: ')
codigo = """
def f(x):
    return %s
""" % formula

exec(codigo)          #converte a cadeia de caracteres em código

#pergunte ao usuário valores de x e avalie f(x)
x = 0
while x is not None:
    x = eval(raw_input('Valor de x (Digite None para sair): '))
    if x is not None:
        y = f(x)
        print 'f(%g)=%g' % (x, y)
                        </code></pre> 
                        <p>Enquanto o programa está rodando o usuário digita
                        a equação, que se transforma em uma função Python, então
                        o usuário fornece um valor para x até que a resposta
                        seja <code>None</code>, e o programa avalia a função 
                        f(x).</p>
                        <p>O programador não tem idéia da escolha do usuário
                            para a função f(x) quando ele escreve o programa!</p>
                        
                        
                    </div>
                    <div class="bs-docs-section" id="exe_4parametros_comandline">
                        <h1 class="page-header">Exemplo lendo 4 parâmetros da linha de
                        comando</h1>
                        
                        $$ s(t)=s_0 + v_0t + {1\over2}at^2$$
                        
                        <p>Dados de entrada: \( s_0 \) 
                            (posição inicial), \( v_0 \) 
                            (velocidade inicial), \( a \) 
                            (aceleração constante) e \( t \) (tempo)</p>
                        <p>Dados de saída: \( s \) (posição atual)</p>
                        
                        Programa:
                        <pre><code class="language-python">
import sys
s0 = float(sys.argv[1])
v0 = float(sys.argv[2])
a  = float(sys.argv[3])
t  = float(sys.argv[4])
s  = s0 + v0*t + 0.5*a*t*t
print s
                        </code></pre> 
                        <p>Salve como posicao_lcm.py</p>                        
                        <p>Especifique \( s_0=1 \) m, \( v_0=1 \) m/s, \( a=0.5 \) $\hbox{m/s}^2$, e
\( t=3 \) s na linha de comando:</p>                        
                        
                        <pre><code class="language-bash">
Terminal> python posicao_lcm.py 1 1 0.5 3
6.25
                        </code></pre> 
                        
                        
                    </div>
                    <div class="bs-docs-section" id="cmd_arg_options">
                        <h1 class="page-header">Argumentos da linha de comando
                        com opções</h1>

                        <p>Muitos programas, especialmente em sistemas Unix, 
                        requerem uma série de argumentos de linha de comando 
                        na forma </p><pre>--opção valor</pre>
                        
                        <pre><code class="language-bash">
Terminal> python posicao_lcm.py --v0 1 --t 3 --s0 1 --a 0.5
Terminal> python posicao_lcm.py --t 3
                        </code></pre> 
                        
                        <p>A última chamada usa os valores padrão para <code>v0</code>,
                        <code>s0</code> e <code>a</code>, nos apenas entramos com
                        os valores que desejamos mudar.</p>
                        <p>Os pares opção-valor tornam mais fácil de entender o 
                        que a entrada é (como os argumentos palavra-chave).</p>
                        
                    </div>
                    <div class="bs-docs-section" id="estrategia">
                        <h1 class="page-header">Programando pares de argumentos
                            opção valor com o <code>argparse</code></h1>

                        <pre><code class="language-python">
import argparse
parser = argparse.ArgumentParser()

# definindo os argumentos de linha de comando
parser.add_argument('--v0', '--velocidade_inicial', type=float,
                    default=0.0, help='velocidade inicial')

parser.add_argument('--s0', '--posicao_inicial', type=float,
                    default=0.0, help='posição inicial')

parser.add_argument('--a', '--aceleracao', type=float,
                    default=1.0, help='aceleração')

parser.add_argument('--t', '--tempo', type=float,
                    default=1.0, help='tempo')

# lendo os argumentos de linha de comando e interpretando
args = parser.parse_args()

# extraindo valores
s = args.s0 + args.v0*args.t + 0.5*args.a*args.t**2
# ou
s0 = args.s0; v0 = args.v0; a = args.a; t = args.t
s = s0 + v0*t + 0.5*a*t**2
                        </code></pre>
                        <p>O programa possui argumentos longo e curtos:</p>
                        <pre><code class="language-bash">
Terminal> python posicao_lcm.py --v0 1.2 --t 0.2
Terminal> python posicao_lcm.py --velocidade_inicial 1.2 --tempo 0.2
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="GUI">
                        <h1 class="page-header">Interfaces gráficas de usuário</h1>

                        <p>A maioria dos programas hoje em dia recebem entradas
                        de uma interface gráfica de usuário (graphical user interfaces - GUI),
                        que consiste em janelas com elementos gráficos como botões,
                        menus, campos de texto, etc.</p>
                        <p>Porque no aprendemos a fazer tais programas?</p>
                        <ul>
                            <li>GUI demandam uma programação extra muito complicada;</li>
                            <li>Programadores experientes preferem a entrada por linha
                            de comando;</li>
                            <li>Programas com entradas por linha de comando ou 
                            arquivos podem ser facilmente combinados uns com
                            os outros, o que é difícil em programas baseados
                            em GUI.</li>
                        </ul>
                        <div class="alert alert-success" role="alert">Entrada
                        por linha de comando provavelmente vai servir para
                        todos os seus propósitos na sua pesquisa de 
                        pós-graduação!</div>
                        <p>A não ser que sua pesquisa envolva diretamente a
                        programação com GUI...</p>
                        <p>Então, vamos dar uma olhada com se faz!</p>
                        
                    </div>
                    <div class="bs-docs-section" id="grafico_C2F">
                        <h1 class="page-header">Um programa de conversão
                        Celsius-Fahrenheit com GUI</h1>

                        <p>Os valores em Celsius podem ser colocados como números
                            em um campo e clicando-se em um botão "é" 
                        calcula-se a correspondente temperatura em Fahrenheit.</p>
                        <p>Para isso, vamos usar o pacote GUI do python chamado
                        Tkinter:</p>
                        <pre><code class="language-python">
import Tkinter as tk
#from Tkinter import *

root = tk.Tk() #iniciando o Tkinter

#criando o campo de entrada à esquerda
C_entry = tk.Entry(root, width=4)
C_entry.pack(side='left')
#criando o texto Celsius logo após o campo de entrada
Cunit_label = tk.Label(root, text='Celsius')
Cunit_label.pack(side='left')

def compute():
    C = float(C_entry.get())
    F = (9./5)*C + 32
    F_label.configure(text='%g' % F)

#criando o botão para calcular o resultado
compute = tk.Button(root, text=' é ', command=compute)
compute.pack(side='left', padx=4)

#criando um texto para a resposta
F_label = tk.Label(root, width=4)
F_label.pack(side='left')
#criando o texto Fahrenheit
Funit_label = tk.Label(root, text='Fahrenheit')
Funit_label.pack(side='left')

root.mainloop()
                        </code></pre>
                        <p>Resulta em:</p>
                        <div class="text-center">
                            <img src="./imagens/GUI-tk.png" alt="Tkinter GUI">
                        </div>
                        
                    </div>
                    <div class="bs-docs-section" id="grafico_PyQt4">
                        <h1 class="page-header">Um exemplo um pouco mais complexo
                        usando o PyQt4</h1>

                        <p>Para ilustrar um pouco mais sobre GUIs, segue um
                        exemplo usando o PyQt4 para avaliar expressões</p>
                        <pre><code class="language-python">
from __future__ import division
import sys
from math import *
from PyQt4.QtCore import *
from PyQt4.QtGui import *

class Form(QDialog):
    def __init__(self, parent=None):
        super(Form, self).__init__(parent)
        self.browser = QTextBrowser()
        self.lineedit = QLineEdit(u"Digite uma expressão e pressione enter")
        self.lineedit.selectAll()
        layout = QVBoxLayout()
        layout.addWidget(self.browser)
        layout.addWidget(self.lineedit)
        self.setLayout(layout)
        self.lineedit.setFocus()
        self.connect(self.lineedit, SIGNAL("returnPressed()"), self.updateUi)
        self.setWindowTitle("Calcular")
    
    def updateUi(self):
        try:
            text = self.lineedit.text().encode('utf-8')
            self.browser.append(u"%s = %s" % (text, eval(text)))
        except:
            self.browser.append(u"%s é inválido!" % text)

app = QApplication(sys.argv)
form = Form()
form.show()
app.exec_()
                        </code></pre>
                        <p>Resulta em:</p>
                        <div class="text-center">
                            <img src="./imagens/GUI-pyqt4.png" alt="Tkinter GUI">
                        </div>
                        
                    </div>
                    <div class="bs-docs-section" id="lendo_arquivos">
                        <h1 class="page-header">Lendo dados de arquivos</h1>

                        <p>Dados científicos comumente estão disponíveis em
                        arquivos. Nós queremos ler os dados para objetos em
                        um programa para poder computar esses dados.</p>
                        <p>Exemplo de um arquivo de dados:</p>
                        <pre>
21.8
18.1
19
23
26
17.8                        </pre>
                        <p>Um número em cada linha. Como podemos ler esses números?</p>
                        
                    </div>
                    <div class="bs-docs-section" id="lendo_arquivos_linha">
                        <h1 class="page-header">Lendo arquivos linha por linha</h1>

                        <p>Leitura de arquivos básica:</p>
                        <pre><code class="language-python">
do_arquivo = open('dados.txt', 'r')    # abrindo arquivo
for linha in do_arquivo:
    # faça alguma coisa com a linha
do_arquivo.close()                    # fechando o arquivo
                        </code></pre>
                        <p>Calculando a soma dos números no arquivo:</p>
                        <pre><code class="language-python">
do_arquivo = open('dados.txt', 'r')    # abrindo arquivo
acumulado = 0
for linha in do_arquivo:
    numero = float(linha)          # a linha é uma cadeia de caracteres
    acumulado += numero
print acumulado
do_arquivo.close()
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="lendo_arquivos_outros">
                        <h1 class="page-header">Formas alternativas de ler um
                        arquivo</h1>

                        <p>Lendo todas as linhas de uma vez na forma de
                        uma lista de cadeias de caracteres (as linhas):</p>
                        <pre><code class="language-python">
linhas = do_arquivo.readlines()
for linha in linhas:
    # processa a linha
do_arquivo.close()
                        </code></pre>
                        <p>A declaração moderna <code>with</code>:</p>
                        <pre><code class="language-python">
with open('dados.txt', 'r') as do_arquivo:
    for linha in do_arquivo:
        # processa a linha
                        </code></pre>
                        <p>A velha construção <code>while</code>:</p>
                        <pre><code class="language-python">
while True:
    linha = do_arquivo.readline()
    if not linha:
        break
    # processa a linha
do_arquivo.close()
                        </code></pre>
                        <p>Lendo o arquivo todo em uma cadeia de caracteres:</p>
                        <pre><code class="language-python">
texto = do_arquivo.read()
# processa o texto da string
                        </code></pre>
                        
                        <p>Mais exemplos:</p>
                        <pre><code class="language-python">
>>> do_arquivo = open('tmp.txt', 'r')
>>> arquivo_str = do_arquivo.read()
>>> arquivo_str
'Linha 1.\nLinha 2.\nLinha 3.\nLinha 4.\n'

>>> arquivo_str.split()  # separa todas as palavras
['Linha', '1.', 'Linha', '2.', 'Linha', '3.', 'Linha', '4.']

>>> linha = 'Linha 3.\n'
>>> linha.split()
['Linha', '3.']
>>> linha.split('e')
['Lin', ' 3.\n']
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="arquivo_texto_conteudo">
                        <h1 class="page-header">Texto e números no arquivo</h1>

                        <p>A maioria dos arquivos de dados contém texto e
                        números no mesmo arquivo:</p>
                        <p>Arquivo com dados de chuvas:</p>
                        <pre>
Média de chuvas (em mm) em Roma: 1188 meses entre 1782 e 1970
Jan  81.2
Fev  63.2
Mar  70.3
Abr  55.7
Mai  53.0
Jun  36.4
Jul  17.5
Ago  27.5
Set  60.9
Out  117.7
Nov  111.0
Dez  97.9
Anual 792.9         </pre>
                        <p>Como ler tal arquivo?!</p>
                        <p>Salve como dados_chuva_roma.dat</p>
                    </div>
                    <div class="bs-docs-section" id="arquivo_texto_conteudo2">
                        <h1 class="page-header">Lendo um arquivo contendo
                        texto e números</h1>

                        <p>A ideia é ler cada linha separando a linha em palavras:</p>
                        <pre><code class="language-python">
meses = []
valores = []
for linha in do_arquivo:
    palavras = linha.split()  # separando em palavras
    if palavras[0] != 'Anual':
        meses.append(palavras[0])
        valores.append(float(palavras[1]))
                        </code></pre>
                        <p>O que está faltando no arquivo acima?</p>
                        <p>Podemos separar em relação a qualquer cadeia de 
                            caractere <code>s</code>: <code>line.split(s)</code></p>
                        <pre><code class="language-python">
>>> linha = 'Out  117.7'
>>> palavras = linha.split()
>>> palavras
['Out', '117.7,']
>>> type(palavras[1])   # cadeia de caracteres, não um número
&LT;type 'str'&GT;
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="leitura_arquivo_completo">
                        <h1 class="page-header">Programa completo para leitura 
                        dos dados de chuva</h1>

                        <pre><code class="language-python">
def extrair_dados(nome_arquivo):
    arquivo = open(nome_arquivo, 'r')
    arquivo.readline() # pular a primeira linha
    meses = []
    chuva = []
    for linha in arquivo:
        palavras = linha.split()
        # palavras[0]: mês, palavras[1]: chuva
        meses.append(palavras[0])
        chuva.append(float(palavras[1]))
    arquivo.close()
    meses = meses[:-1]      # removendo a entrada "Ano"
    media_anual = chuva[-1] # armazenando a média anual
    chuva = chuva[:-1]  # Redefinindo para conter os dados mensais
    return meses, chuva, media_anual

meses, valores, media = extrair_dados('dados_chuva_roma.dat')
print 'A média de chuvas para os meses:'
for mes, valor in zip(meses, valores):
    print mes, valor
print 'A média de chuva para o ano:', media
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="escrevendoArquivoDados">
                        <h1 class="page-header">Escrevendo dados para arquivos</h1>

                        <p>Declarações básicas:</p>
                        <pre><code class="language-python">
arquivo_saida = open(nome_arquivo, 'w')  # 'w' para escrever!

for dado in algumaLista:
    arquivo_saida.write(algumTexto + dado + '\n')

arquivo_saida.close()
                        </code></pre>
                        <p>Se o arquivo já existir e você deseja acrescentar mais
                            dados, pode ser feito com <code>open(nomeArquivo, 'a')</code></p>
                    </div>
                    <div class="bs-docs-section" id="escrevendo_tabela_arquivo">
                        <h1 class="page-header">Exemplo: escrevendo uma tabela
                        em um arquivo</h1>

                        <p>Temos a lista:</p>
                        <pre><code class="language-python">
dados = \
[[ 0.75,        0.29619813, -0.29619813, -0.75      ],
 [ 0.29619813,  0.11697778, -0.11697778, -0.29619813],
 [-0.29619813, -0.11697778,  0.11697778,  0.29619813],
 [-0.75,       -0.29619813,  0.29619813,  0.75      ]]
                        </code></pre>
                        <p>Como escrever em um arquivo na forma tabular?</p>
                        <pre><code class="language-python">
arquivo_saida = open('tmp_tabela.dat', 'w')
for linha in dados:
    for coluna in linha:
        arquivo_saida.write('%14.8f' % coluna)
    arquivo_saida.write('\n')
arquivo_saida.close()
                        </code></pre>
                        <p>Resultado no arquivo:</p>
                        <pre>
    0.75000000    0.29619813   -0.29619813   -0.75000000
    0.29619813    0.11697778   -0.11697778   -0.29619813
   -0.29619813   -0.11697778    0.11697778    0.29619813
   -0.75000000   -0.29619813    0.29619813    0.75000000 </pre>
                        
                    </div>
                    <div class="bs-docs-section" id="oqueEarquivo">
                        <h1 class="page-header">O que é um arquivo?</h1>

                        <ul>
                            <li> Um arquivo é uma sequência de caracteres;</li>
                            <li> Para arquivos simples de texto, cada caractere é 
                                um byte (=8 bits, um bit é 0 ou 1), o que resultam em 
                                \( 2^8=256 \) caracteres diferentes;</li>
                            <li> Arquivos de texto em, por exemplo, Chinês ou Japonês precisam de vários bytes para cada caractere;</li>
                            <li> Salve o texto "ABCD" em um arquivo no Gedit/Emacs/Editor de Texto/Notepad++ e LibreOffice/Word e examine o arquivo!</li>
                            <li> A leitura de arquivo em Python é o ato de ler todos os caracteres (<code>read</code>) ou
                              ler linha por linha (<code>readline</code>, <code>readlines</code>, <code>for linha in objArquivo</code>)</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="errosEntradaUsuario">
                        <h1 class="page-header">Como evitar erros de entrada
                        de usuário</h1>

                        <p>Voltando ao programa C2F:</p>
                        <pre><code class="language-python">
import sys
C = float(sys.argv[1])
F = 5./9*C + 32
print F
                        </code></pre>
                        <p>Nosso programa para com uma mensagem de erro estranha 
                        quando não é passado nada como argumento de linha de comando:</p>
                        <pre><code class="language-bash">
Terminal> python c2f.py
Traceback (most recent call last):
  File "c2f.py", line 2, in ?
    C = float(sys.argv[1])
IndexError: list index out of range
                        </code></pre>
                        <p>Porque?</p>
                        <ol>
                            <li> O usuário esquece de escrever o argumento de linha de comando;</li>
                            <li> <code>sys.argv</code> então possui apenas um elemento, <code>sys.argv[0]</code>,
                               que é o nome do programa <code>c2f.py</code>;</li>
                            <li> Índice 1, em <code>sys.argv[1]</code>, aponta para um 
                                elemento inexistente na lista <code>sys.argv</code>;</li>
                            <li> Qualquer índice correspondente a um elemento
                                inexistente leva a um <code>IndexError</code>.</li>
                        </ol>
                        
                    </div>
                    <div class="bs-docs-section" id="manipulandoErros">
                        <h1 class="page-header">Nós devemos manipular erros de entrada!</h1>

                        <p>Como podemos ter controle, explicar o que está errado
                        na entrada e parar o programa sem uma mensagem de
                        erro estranha?</p>
                        <pre><code class="language-python">
# Program c2f_ctrl.py

import sys
if len(sys.argv) < 2:
    print 'Você não passou nenhum argumento na linha de comando!'
    sys.exit(1)  # abortando
F = 9.0*C/5 + 32
print '%gC is %.1fF' % (C, F)
                        </code></pre>
                        <pre><code class="language-bash">
Terminal> python c2f_ctrl.py
Você não passou nenhum argumento na linha de comando!
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="excecoes_paraIfs">
                        <h1 class="page-header">Exceções como uma alternativa para
                        ramificações</h1>

                        <p>Ao invés de testar se algo está errado, recuperar do erro e
                        fazer o que era para ser feito é comum em python (e muitas
                        outras linguagens) tentar fazer o que deveria ser feito e
                        se falhar, recuperar do erro.</p>
                        <p>Esse princípio faz o uso do bloco <code>try-except</code></p>
                        <pre><code class="language-python">
try:
    &lt;declarações que queremos executar&gt;
except:
    &lt;declarações para manipular erros&gt;
                        </code></pre>
                        <p>Se algo vai errado no bloco <code>try</code>, o Python
                        levanta uma exceção e a execução pula imediatamente
                        para o bloco <code>except</code>.</p>
                        
                    </div>
                    <div class="bs-docs-section" id="cf2_try_except">
                        <h1 class="page-header">O programa de conversão de
                            temperatura com <code>try-except</code></h1>
                        <p>Tente ler <code>C</code> da linha de comando, se
                        falhar, avise ao usuário e aborte a execução. Salve como 
                        c2f_try_except.py:</p>
                        <pre><code class="language-python">
import sys
try:
    C = float(sys.argv[1])
except:
    print 'Você falhou ao passar um argumento de linha de comando!'
    sys.exit(1)  # aborta
F = 9.0*C/5 + 32
print '%gC is %.1fF' % (C, F)
                        </code></pre>   
                        <p>Execução:</p>
                        <pre><code class="language-bash">
Terminal> python c2f_try_except.py
Você falhou ao passar um argumento de linha de comando!

Terminal> python c2f_try_except.py 21C
Você falhou ao passar um argumento de linha de comando!
                        </code></pre> 
                    </div>
                    <div class="bs-docs-section" id="excecoes_especificas">
                        <h1 class="page-header">Um bom estilo de programação testa
                        por exceções específicas</h1>

                        <pre><code class="language-python">
try:
    C = float(sys.argv[1])
except IndexError:
    print 'Você falhou ao passar um argumento de linha de comando!'
                        </code></pre>  
                        
                        <p>Se tivermos um índice fora dos limites em <code>sys.argv</code>
                            uma exceção <code>IndexError</code> é levantada e a
                            execução salta automaticamente para o bloco <code>except</code>.</p>
                        <p>Se qualquer outra exceção for levantada, o Python aborta
                        a execução.</p>
                        <pre><code class="language-bash">
Terminal> python c2f_try_except.py 21C
Traceback (most recent call last):
  File "c2f_try_except.py", line 3, in &lt;module&gt;
    C = float(sys.argv[1])
ValueError: invalid literal for float(): 21C
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="index_value_errors">
                        <h1 class="page-header">Testando para as exceções
                            <code>IndexError</code> e <code>ValueError</code></h1>

                        <pre><code class="language-python">
import sys
try:
    C = float(sys.argv[1])
except IndexError:
    print 'Nenhum argumento na linha de comando para C!'
    sys.exit(1)  # abort execution
except ValueError:
    print 'Graus Celsius devem ser um número, não "%s"' % sys.argv[1]
    sys.exit(1)

F = 9.0*C/5 + 32
print '%gC é %.1fF' % (C, F)
                        </code></pre>
                        Execuções:
                        <pre><code class="language-bash">
Terminal> python c2f_try_except.py
Nenhum argumento na linha de comando para C!

Terminal> python c2f_try_except.py 21C
Graus Celsius devem ser um número, não "21C"
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="excecoes_programador">
                        <h1 class="page-header">O programador pode levantar
                        exceções</h1>

                        <p>Ao invés de simplesmente deixar o Python levantar exceções,
                        nós podemos levantar a nossa própria e adaptar a mensagem
                        do problema em mãos.</p>
                        <p>Dois exemplos:</p>
                        <ul>
                            <li>pegando uma exceção, mas levantando uma nova exceção com
                            uma mensagem de erro melhorada;</li>
                            <li>levantando uma exceção por causa de entrada de dados
                            errada.</li>
                        </ul>
                        <p>Sintaxe básica: <code>raise ExceptionType(mensagem)</code></p>                        
                    </div>
                    <div class="bs-docs-section" id="levantando_novamente_execoes">
                        <h1 class="page-header">Exemplos no levantamento de exceções
                        com mensagens melhores</h1>
                        <pre><code class="language-python">
def ler_C():
    try:
        C = float(sys.argv[1])
    except IndexError:
        # levantando novamente, mas com explicação específica:
        raise IndexError(
          'Graus Celsius dever ser fornecidos na linha de comando')
    except ValueError:
        # levantando novamente, mas com explicação específica:
        raise ValueError(
         'Graus Celsius devem ser um número, não "%s"' % sys.argv[1])

    # C pode ser lido como corretamente como número, mas com valor errado:
    if C < -273.15:
        raise ValueError('C=%g não é um valor físico!' % C)
    return C
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="levantando_novamente_execoes2">
                        <h1 class="page-header">Chamando a função anterior e
                        rodando o programa</h1>

                        <pre><code class="language-python">
try:
    C = ler_C()
    F = 9.0*C/5 + 32
    print '%gC é %.1fF' % (C, F)
except (IndexError, ValueError) as e:
    # mostre a exceção e pare o programa
    print e
    sys.exit(1)
                        </code></pre>
                        <p>Execuções:</p>
                        <pre><code class="language-bash">
Terminal> c2f_try_except.py
Graus Celsius dever ser fornecidos na linha de comando

Terminal> c2f_try_except.py 21C
Graus Celsius devem ser um número, não "21C"

Terminal> c2f_try_except.py -500
C=-500 não é um valor físico!

Terminal> c2f_try_except.py 21
21C é 69.8F
                        </code></pre> 
                        
                    </div>
                    <div class="bs-docs-section" id="modulos">
                        <h1 class="page-header">Fazendo os nossos próprios módulos</h1>

                        <p>Nós já usamos módulos como o <code>math</code> e o <code>sys</code>:</p>
                        <pre><code class="language-python">
import math
r = math.log(6)   # chama a função log no módulo math
                        </code></pre>
                        <pre><code class="language-python">
import sys
# acessa a lista de argumentos da linha de comendo no módulo sys
x = eval(sys.argv[1]) 
                        </code></pre>
                        <p>Características dos módulos:</p>
                        <ul>
                            <li>Coleção de dados úteis e funções (também classes);</li>
                            <li>Funções em um módulo podem ser reutilizadas em vários
                            diferentes programas;</li>
                            <li>Se você tem algumas funções gerais que podem ser
                            utilizadas em mais de um programa, faça um módulo com 
                            essas funções.</li>
                            <li>É fácil: apenas colete as funções que você quer
                            em um arquivo e pronto, temos um módulo!</li>
                        </ul>
                        
                    </div>
                    <div class="bs-docs-section" id="modulo_proprio">
                        <h1 class="page-header">Fazendo nosso próprio módulo</h1>

                        <p>Aqui estão algumas formulas para cálculo com taxas de juros:</p>
                        $$
                        \begin{align}
                        A &= A_0\left( 1 + {p\over 360\cdot 100}\right)^{n},
                        \label{input:mod:eq1}\\
                        A_0 &= A\left( 1 + {p\over 360\cdot 100}\right)^{-n},
                        \label{input:mod:eq2}\\
                        n &= \frac{\ln {A\over A_0}}{\ln \left( 1 + {p\over 360\cdot 100}\right)} ,
                        \label{input:mod:eq3}\\
                        p &= 360\cdot 100 \left[\left({A\over A_0}\right)^{1/n} - 1\right].
                        \label{input:mod:eq4}
                        \end{align}
                        $$
                        
                        <p>Sendo \( A_0 \): montante inicial, \( p \): taxa,
                            \( n \): dias, \( A \): montante final.</p>
                        <p>Queremos fazer um módulo com essas equações.</p>
                    </div>
                    <div class="bs-docs-section" id="modulo_proprio_funcoes">
                        <h1 class="page-header">Primeiro fazemos funções Python
                        com as equações</h1>

                        <pre><code class="language-python">
import math

def montante_final(A0, p, n):
    return A0*(1 + p/(360.0*100))**n

def montante_inicial(A, p, n):
    return A*(1 + p/(360.0*100))**(-n)

def dias(A0, A, p):
    return math.log(A/A0)/math.log(1 + p/(360.0*100))

def taxa_anual(A0, A, n):
    return 360*100*((A/A0)**(1.0/n) - 1)
                        </code></pre>
                        
                    </div>
                    <div class="bs-docs-section" id="modulo_proprio_modulo">
                        <h1 class="page-header">Então podemos fazer o módulo</h1>

                        <p>Salve as 4 funções em um arquivo taxas_juros.py</p>
                        <p>Pronto! Agora taxas_juros.py é um módulo.</p>
                        <p>Exemplo de uso:</p>
                        <pre><code class="language-python">
import taxas_juros as tj

A0 = 1
A = 2
p = 5
n = tj.dias(A0, 2, p)
anos = n/365.0
print 'O dinheiro dobrou após %.1f anos' % anos
                        </code></pre>
                        
                    </div>                    
                    <div class="bs-docs-section" id="bloco_teste_modulo">
                        <h1 class="page-header">Adicionando um bloco de teste em
                        um módulo</h1>

                        <ul>
                            <li>Módulos podem ter um teste <code>if</code> no final
                            contendo um bloco de teste para testar ou demonstrar
                            o funcionamento do próprio módulo;</li>
                            <li>O bloco de teste não é executado quando o arquivo 
                            é importado como um módulo em um programa;</li>
                            <li>O bloco de teste é executado somente quando o arquivo
                            roda como um programa!</li>
                        </ul>
                        <p>Sintaxe básica:</p>
                        <pre><code class="language-python">
if __name__ == '__main__': # esse teste define o bloco de teste
    &lt;block of statements&gt;
                        </code></pre>
                        <p>No nosso caso, acrescenta-se logo após as funções:</p>
                        <pre><code class="language-python">
if __name__ == '__main__':
    A = 2.2133983053266699
    A0 = 2.0
    p = 5
    n = 730
    print 'A=%g (%g) A0=%g (%.1f) n=%d (%d) p=%g (%.1f)' % \
          (montante_final(A0, p, n), A,
           montante_inicial(A, p, n), A0,
           dias(A0, A, p), n,
           taxa_anual(A0, A, n), p)
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="blocos_teste_efuncoes">
                        <h1 class="page-header">Blocos de teste normalmente
                            coletados em funções
                        </h1>

                        <p>Vamos fazer uma função de teste real para testar
                        o que temos no bloco de teste:</p>
                        <pre><code class="language-python">
def teste_todas_funcoes():
    # Definindo valores compatíveis
    A = 2.2133983053266699
    A0 = 2.0
    p = 5
    n = 730
    # Dados três desses valores, calcule o remanescente
    # e compare com o valor correto (em parênteses)
    A_calculado = montante_final(A0, p, n)
    A0_calculado = montante_inicial(A, p, n)
    n_calculado = dias(A0, A, p)
    p_calculado = taxa_anual(A0, A, n)
    def float_eq(a, b, tolerancia=1E-12):
        """Retorne True if a == b dentro da tolerância."""
        return abs(a - b) < tolerancia

    success = float_eq(A_calculado,  A)  and \
              float_eq(A0_calculado, A0) and \
              float_eq(p_calculado,  p)  and \
              float_eq(n_calculado,  n)
    assert success  # pode-se adicionar uma mensagem aqui se desejado

if __name__ == '__main__':
    teste_todas_funcoes()
                        </code></pre>
                    </div>
                    <div class="bs-docs-section" id="bucando_novo_modulo">
                        <h1 class="page-header">Como o Python pode encontrar
                        nosso novo módulo?</h1>

                        <ul>
                            <li>Se o módulo está no mesmo diretório do programa
                            principal, ele é importado sem problema algum;</li>
                            <li>Módulos por nós confeccionados são normalmente
                            colecionados em um diretório comum, por exemplo:
                            <pre>/home/usuario/Documentos/meusModulos</pre></li>
                            <li>Nesse caso o Python precisa ser avisado que seus
                            módulos estão naquele diretório!</li>
                        </ul>
                        <p><b>Técnica 1:</b> adicione o diretório ao <code>PYTHONPATH</code>
                            no arquivo <code>.bashrc</code>, no caso de sistemas Linux:</p>
                        <pre><code class="language-python">
export PYTHONPATH=$PYTHONPATH:/home/usuario/Documentos/meusModulos
                        </code></pre>
                        <p><b>Técnica 2:</b> adicione o diretório ao <code>sys.path</code>
                        no programa:</p>
                        <pre><code class="language-python">
sys.path.insert(0, '/home/usuario/Documentos/meusModulos')
                        </code></pre>
                        <p><b>Técnica 3:</b> copie o arquivo do módulo para um
                        diretório o qual o Python já busca por módulos.</p>
                    </div>
                    
                    <div class="bs-docs-section" id="final">
                        <h1 class="page-header">Tarefa</h1>
                        <p>
                            Resolução de $f(x)=0$ para equações não lineares
                            utilizando método da bisecção.
                        </p>           
                        <p>Equações não lineares para serem resolvidas:</p>
                        $$
                        \begin{align*}
                        f(x) &= x - 1 - \sin x\\
                        f(x) &= \tan x + \cos x - \sin 8x\\\
                        f(x) &= x^5 - 3x^3 -  10
                        \end{align*}
                        $$
                        
                        <p>O método da bisecção:</p>
                        
                        <ul>
                            <li> Inicie com um intervalo \( [a,b] \) no qual 
                                \( f(x) \) muda de sinal;</li>
                            <li> Então deve haver ao menos uma raiz em 
                                \( [a,b] \);</li>
                            <li> Reduza o intervalo à metade:
                            <ul>
                                <li> \( m=(a+b)/2 \); faz \( f \) mudar de sinal 
                                    na metade da esquerda \( [a,m] \)?
                                    <ul>
                                        <li> Sim: continue com o intervalo da esquerda 
                                    \( [a,m] \) (faça \( b=m \));</li>
                                <li> Não: continue com o intervalo da direita 
                                    \( [m,b] \) (faça \( a=m \)).</li>
                                    </ul>
                                </li>                            
                            </ul>
                            </li>
                            <li> Repita o procedimento!</li>
                        </ul>
                        
                        <ul>
                            <li> Após reduzir o intervalo inicial à metade 
                                \( [p,q] \) $n$ vezes, sabemos que \( f(x) \) 
                                deve ter uma raiz dentro de um intervalo (pequeno) 
                                \( 2^{-n}(q-p) \);</li>
                            <li> O método é lento, mas muito confiável.</li>
                            <li> Outros métodos (como Newton-Raphson) podem ser
                                mais rápidos, mas podem também falhar ao
                                localizar a raiz, o método da bisecção não falha.</li>
                        </ul>
                        
                        <p>Como fazer:</p>
                        <ul>
                            <li>Precisa-se transcrever a descrição matemática
                            do método da bisecção para um programa Python;</li>
                            <li>Um passo intermediário importante é formular um
                            algoritmo preciso!</li>
                        </ul>
                        
                        <p>Como escolher $n$? Ou seja, quando parar a iteração.</p>
                        <ul>
                            <li> Queremos que o erro na raiz seja \( \epsilon \) (tolerância) ou menor;</li>
                            <li> Após \( n \) iterações, o intervalo inicial 
                                \( [a,b] \) é dividido à metade \( n \) vezes
                                e o intervalo atual tem tamanho \( 2^{-n}(b-a) \). 
                                Isso é suficientemente pequeno se 
                                \( 2^{-n}(b-a) = \epsilon \quad\Rightarrow 
                                \quad n = - \dfrac{\ln\epsilon -\ln (b-a)}{\ln 2} \);</li>
                            <li> Uma alternativa simples: apenas repita a divisão à metade
                                até que o comprimento do intervalo atual
                                seja \( \leq\epsilon \);</li>
                            <li> Podemos também adicionar um teste para verificar
                                se \( f \) realmente muda de sinal no intervalo
                                inicial \( [a,b] \).</li>
                        </ul>            
                        
                        <p>Opcional: Deixando o algoritmo mais eficiente</p>
                        <ul>
                            <li> \( f(a) \) é recalculada a cada teste <code>if</code>;</li>
                            <li> Não é necessário se \( a \) não mudou de sinal
                                desde o último passo no laço;</li>
                            <li> Em computadores modernos e com fórmulas simples
                                para \( f(x) \) esses cálculos extras não
                                importam;</li>
                            <li> No entanto, na ciência e na engenharia existem
                                funções \( f \) que levam horas e até dias para
                                serem avaliadas em um ponto, então salvar alguma
                                avaliação de \( f(a) \) importa!</li>
                            <li> Regra geral: remova cálculos redundantes <br />
                                (a não ser que o código se torne muito complicado
                                e difícil de verificar)</li>
                        </ul>
                        
                        <p><b>Regras à cumprir:</b></p>
                        <ol>
                            <li>Passe todos os dados necessários, função, limites
                            e tolerância via argumentos de linha de comando com 
                            opções (<code>argparse</code>);</li>
                            <li>O método da bisecção deve ser implementado
                            como uma função em um módulo à parte!</li>
                            <li>Faça ao menos uma função teste para o método
                            da bisecção;</li>
                            <li>Limitação: use somente o aprendido até aqui!</li>
                        </ol>

                        <!--SOLUÇÃO DA TAREFA-->
                        <button type="button" class="btn btn-info disabled">Solução</button>                        
                        <!--<button type="button" class="btn btn-info" data-toggle="collapse" data-target="#tarefa">Solução</button>-->
                        <!--Final solução da tarefa-->                        

                        <div id="tarefa" class="collapse">
                            <h3> Exemplo de solução: </h3>

                            <pre><code class="language-python">
import math
import argparse

parser = argparse.ArgumentParser()

# definindo os argumentos de linha de comando
parser.add_argument('--f', '--funcao', type=str,
                    default='x**3', help='função não linear')

parser.add_argument('--a', '--limite_inferior', type=float,
                    default=0.0, help='limite inferior do domínio')

parser.add_argument('--b', '--limite_superior', type=float,
                    default=1.0, help='limite superior do domínio')

parser.add_argument('--tol', '--tolerancia', type=float,
                    default=1.0E-5, help='tolerância')

# lendo os argumentos de linha de comando e interpretando
args = parser.parse_args()
#exemplo de uso:
#python biseccao.py --f 'lambda x: 2*x-3' --a 0 --b 10 --tol 1e-5

def biseccao(f, a, b, tol=1.0E-5):
    fa = f(a)
    if fa*f(b) > 0:
        raise ValueError('Não muda de sinal em [%g,%g]' % (a, b))

    i = 0   # contador de iteração
    while b-a > tol:
        i += 1
        m = (a + b)/2.0
        fm = f(m)
        if fa*fm <= 0:
            b = m   # raiz está na metade esquerda de [a,b]
        else:
            a = m   # raiz está na metade direita de [a,b]
            fa = fm
    return m, i

print biseccao(f=eval(args.f), a=args.a, b=args.b, tol=args.tol)

def test_biseccao():
    def f(x):
        return 2*x - 3   # somente uma raiz x=1.5

    tol = 1E-5
    x, iter = biseccao(f, a=0, b=10, tol=tol)
    success = abs(x - 1.5) < tol  # teste dentro da tolerância tol
    assert success, 'encontrado x=%g != 1.5' % x

if __name__ == '__main__':
    test_biseccao()  
                            </code></pre>
                        </div>

                    </div>
                    
                </div>
                <!-- FINAL Conteúdo Principal -->
                
                <!-- Menu lateral -->
                <div class="col-md-3" role="complementary"> 
                    <nav class="bs-docs-sidebar hidden-print hidden-sm hidden-xs affix-top" id="menuLateral"> 
                        <ul class="nav bs-docs-sidenav"> 
                            <li><a href="#inicio">Entrada do usuário e manipulação de erros</a></li>
                        </ul> 
                        <a href="#top" class="back-to-top"> Voltar ao topo </a>                 
                    </nav> 
                </div>
                <!-- FINAL Menu lateral -->
                
            </div>
        </div>
        <!-- FINALParte principal -->
        
        <!-- Rodapé -->
        <footer class="bs-docs-footer"> 
            <div class="container"> 
                <ul class="bs-docs-footer-links"> 
                    <li><a href="http://www.estruturas.ufpr.br" target="_blank">estruturas.UFPR</a></li> 
                    <li><a href="http://www.estruturas.ufpr.br/disciplinas/pos-graduacao/introducao-a-computacao-cientifica-com-python/" target="_blank">Introdução à computação científica</a></li> 
                    <li><a href="https://www.python.org/" target="_blank">Python.org</a></li> 
                    <li><a href="https://www.python.org/dev/peps/pep-0257/" target="_blank">Docstring Conventions</a></li> 
                </ul> 
                <p>
                    Prof. Marco André Argenta
                </p> 
            </div> 
        </footer>
        <!-- FINAL Rodapé -->        
        
        <script src="../adicionais/jquery.min.js"></script>
        <script src="../adicionais/bootstrap.min.js"></script>
        <script src="./js/docs.min.js"></script>
        <script src="./js/prism.js"></script>
    </body>
</html>
